/*******************************************************************************
 *	@file			DLGraph.h
 *	@brief			DirectX Library
 *
 *	@date			21-Apr-2010(Wed)
 ******************************************************************************/

#ifndef	__DLGRAPH_INCLUDE__
#define	__DLGRAPH_INCLUDE__

// vvZbT---------------------------------------------------------------
#include "DL.h"

#ifdef __cplusplus
extern "C" {
#endif

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// 萔`---------------------------------------------------------------------
#pragma once

// 񋓌^`-------------------------------------------------------------------
/*******************************************************************************
 *	@enum		enumDraw		DLGraph.h		"DLGraph.h"
 *	@brief		`
 ******************************************************************************/
enum enumDraw
{
	enumDraw_Null			= 0,												//!< Ȃ
	enumDraw_On,																//!< `悷
	enumDraw_Off,																//!< `悵Ȃ
	enumDraw_Max,
};

/*******************************************************************************
 *	@enum		enumState		DLGraph.h		"DLGraph.h"
 *	@brief		Xe[g
 ******************************************************************************/
enum enumState
{
	enumState_Null			= 0,												//!< Ȃ
	enumState_Normal,															//!< ʏ
	enumState_Translucent,														//!< 
	enumState_Add,																//!< Z
	enumState_Sub,																//!< Z
	enumState_Max,
};

/*******************************************************************************
 *	@enum		enumTex			DLGraph.h		"DLGraph.h"
 *	@brief		eNX`
 ******************************************************************************/
enum enumTex
{
	enumTex_Null			= 0,												//!< Ȃ
	enumTex_Texture,															//!< eNX`
	enumTex_File,																//!< t@C
	enumTex_Memory,																//!< 
	enumTex_Max,
};

// \̒`-------------------------------------------------------------------
/*******************************************************************************
 *	@struct		SDLGraph		DLGraph.h		"DLGraph.h"
 *	@brief		Graphics\
 ******************************************************************************/
struct SDLGraph
{
	SDLGraph( void )
		: m_nWidth( 0 )
		, m_nHeight( 0 )
		, m_bMode( FALSE )
	{
	}

	//
	int						m_nWidth;											//!< 
	int						m_nHeight;											//!< 
	BOOL					m_bMode;											//!< [h
};

/*******************************************************************************
 *	@struct		D3DVERTEX		DLGraph.h		"DLGraph.h"
 *	@brief		_\
 ******************************************************************************/
struct D3DVERTEX
{
	float					x, y, z;											//!< ʒuW
	float					rhw;												//!< ̋t
	D3DCOLOR				color;												//!< _F
	float					tu, tv;												//!< eNX`W
};

/*******************************************************************************
 *	@struct		D3DTEXTURE		DLGraph.h		"DLGraph.h"
 *	@brief		eNX`\
 ******************************************************************************/
struct D3DTEXTURE
{
	D3DTEXTURE()
		: m_lpD3DTex( NULL )
		, m_D3DDesc()

		, m_eTex( enumTex_Null )

		, m_szName()
		, m_byData( NULL )
		, m_nSize( 0 )
		, m_dwColor( 0x00000000 )
	{
	}

	//
	LPDIRECT3DTEXTURE9		m_lpD3DTex;											//!< eNX`
	D3DSURFACE_DESC			m_D3DDesc;											//!< \[X

	enumTex					m_eTex;												//!< eNX`tO

	LPCSTR					m_szName;											//!< O
	BYTE*					m_byData;											//!< f[^
	int						m_nSize;											//!< f[^TCY
	DWORD					m_dwColor;											//!< ߐF
};

/*******************************************************************************
 *	@struct		D3DFONT			DLGraph.h		"DLGraph.h"
 *	@brief		tHg\
 ******************************************************************************/
struct D3DFONT
{
	D3DFONT()
		: m_lpD3DFont( NULL )

		, m_szName()
		, m_nHeight( 0 )
	{
	}

	//
	LPD3DXFONT				m_lpD3DFont;										//!< tHg

	LPCSTR					m_szName;											//!< O
	int						m_nHeight;											//!< 
};

/*******************************************************************************
 *	@struct		D3DDATA			DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNgf[^\
 ******************************************************************************/
struct D3DDATA
{
	D3DDATA()
		: m_nDataMax( 0 )
		, m_pData( NULL )
	{
	}

	//
	int						m_nDataMax;											//!< f[^
	D3DVERTEX*				m_pData;											//!< f[^
};

/*******************************************************************************
 *	@struct		D3DTEXT			DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNgeLXg\
 ******************************************************************************/
struct D3DTEXT
{
	D3DTEXT()
		: m_reRect()
		, m_dwColor( 0x00000000 )
		, m_szStr()
	{
	}

	//
	RECT					m_reRect;											//!< \`
	DWORD					m_dwColor;											//!< \F

	LPSTR					m_szStr;											//!< iAhX̂݁j
};

/*******************************************************************************
 *	@struct		D3DOBJECT		DLGraph.h		"DLGraph.h"
 *	@brief		IuWFNg\
 ******************************************************************************/
struct D3DOBJECT
{
	D3DOBJECT()
		: m_bUsed( FALSE )
		, m_eObj( enumObject_Null )
		, m_nPrio( -1 )
		, m_nMatNum( -1 )
		, m_eState( enumState_Null )
		, m_eDraw( enumDraw_Null )
		, m_pD3DState( NULL )
	{
	}

	// {
	BOOL					m_bUsed;											//!< gptO
	enumObject				m_eObj;												//!< IuWFNg
	int						m_nPrio;											//!< `vCIeB
	// f
	int						m_nMatNum;											//!< fޔԍ
	// 
	enumState				m_eState;											//!< Xe[gtO
	// `
	enumDraw				m_eDraw;											//!< `tO
	LPDIRECT3DSTATEBLOCK9	m_pD3DState;										//!< Xe[gubN

	// ėpf[^
	void*					m_pObj;												//!< ėpf[^
};

// NX-----------------------------------------------------------------------
/*******************************************************************************
 *	@class		CDLGraph		DLGraph.h			"DLGraph.h"
 *	@brief		CDLGraphNX
 ******************************************************************************/
class CDLGraph
{
// 萔`---------------------------------------------------------------------
private:
protected:
public:
	static const int TEXTURE_MAX	= 256;										//!< eNX`
	static const int FONT_MAX		= 32;										//!< tHg
	static const int OBJECT_MAX		= 512;										//!< IuWFNg

// o֐-------------------------------------------------------------------
private:
	static int ( CDLGraph::*StepDel[ enumObject_GraphEnd - enumObject_GraphStart ] )( const int& nNum );
	static int ( CDLGraph::*StepDraw[ enumObject_GraphEnd - enumObject_GraphStart ] )( D3DOBJECT *pObj );

	BOOL SetViewPort( const int& nWidth,
					  const int& nHeight );										//!< r[|[g̐ݒ
	BOOL DeviceRestore( const HRESULT& hRes );									//!< foCX̕
	void SetState( D3DOBJECT* Obj );											//!< Xe[g̐ݒ

	void Cleanup( void );														//!< \[X
	void Reconstruct( void );													//!< č\z

	int Sort( void );															//!< \[g

	// fލēǂݍ
	int ReloadTex( const int& nNum );											//!< eNX`ēǂݍ
	int ReloadBmp( const int& nNum );											//!< 摜ēǂݍ
	int ReloadMem( const int& nNum );											//!< ēǂݍ
	int ReloadFont( const int& nNum );											//!< tHgč쐬

	// IuWFNg폜
	int DelRect( const int& nNum );												//!< `폜
	int DelVertex( const int& nNum );											//!< ʍ폜
	int DelText( const int& nNum );												//!< eLXg폜

	// IuWFNg`
	int DrawPrimitiveUP( D3DOBJECT *pObj );										//!< v~eBu`
	int DrawText( D3DOBJECT *pObj );											//!< eLXg`

protected:
public:
	CDLGraph( void );
	~CDLGraph( void );

	void SetGraph( const SDLGraph& SGraph );									//!< ZbgAbv\̐ݒ

	int Init( const HWND& hWnd );												//!< 
	int Init( const HWND& hWnd,
			  const int& nWidth,
			  const int& nHeight,
			  const BOOL& bMode );												//!< 
	int End( void );															//!< I

	int Update( void );															//!< ʍXV

	int ChangeDisplay( const int& nPosX,
					   const int& nPosY,
					   const int& nWidth,
					   const int& nHeight,
					   const BOOL& bMode );										//!< ʐ؂ւ

	// ڊ
	D3DTEXTURE* GetTexture( const int& nNum );									//!< eNX`擾
	D3DFONT* GetFont( const int& nNum );										//!< tHg擾
	D3DOBJECT* GetObject( const int& nNum );									//!< IuWFNg擾

	// fޓǂݍ
	int LoadTex( const int& nNum,
				 const LPBYTE& lpBuf,
				 const int& nSize,
				 const int& nWidth,
				 const int& nHeight,
				 const DWORD& dwColor );										//!< eNX`̐VK쐬
	int LoadBmp( const int& nNum,
				 const LPCSTR& szName,
				 const DWORD& dwColor );										//!< 摜ǂݍ
	int LoadMem( const int& nNum,
				 const LPBYTE& lpBuf,
				 const int& nSize,
				 const DWORD& dwColor );										//!< ǂݍ
	int LoadFont( const int& nNum,
				  const LPCSTR& szName,
				  const int& nHeight );											//!< tHg쐬

	// fމ
	int RemoveTex( const int& nNum );											//!< eNX`
	int RemoveBmp( const int& nNum );											//!< 摜
	int RemoveMem( const int& nNum );											//!< 
	int RemoveFont( const int& nNum );											//!< tHg
	int RemoveALL( void );														//!< fޑS

	// IuWFNgǉ
	int AddRect( const int& nNum,
				 const int& nPrio,
				 const int& nMatNum,
				 const enumDraw& eDraw,
				 const enumState& eState,
				 const RECT& rcRect,
				 const int& nColor );											//!< `ǉ
	int AddVertex( const int& nNum,
				   const int& nPrio,
				   const int& nMatNum,
				   const enumDraw& eDraw,
				   const enumState& eState,
				   const int& nVertex,
				   const D3DVERTEX* SVertex );									//!< ʒǉ
	int AddText( const int& nNum,
				 const int& nPrio,
				 const int& nMatNum,
				 const enumDraw& eDraw,
				 const RECT& rcRect,
				 const int& nColor,
				 const LPSTR& lpStr );											//!< eLXgǉ

	// IuWFNg폜
	int Del( const int& nNum );													//!< IuWFNg폜
	int DelALL( void );															//!< IuWFNgS폜

// oϐ-------------------------------------------------------------------
private:
	LPDIRECT3D9				m_lpD3D;											//!< Direct3D IuWFNg
	LPDIRECT3DDEVICE9		m_lpD3DDev;											//!< Direct3D foCX

	HWND					m_hWnd;												//!< EChEnh
	SDLGraph				m_SGraph;											//!< ZbgAbv\
	D3DPRESENT_PARAMETERS	m_D3DPP;											//!< foCX\
	D3DDISPLAYMODE			m_D3DDM;											//!< fBXvC̏
	D3DVIEWPORT9			m_D3DVP;											//!< r[|[g\

	// \[g
	int						m_nOTMax;											//!< e[uő吔
	int						m_nOT[ OBJECT_MAX ];								//!< `e[u

	// IuWFNg
	D3DTEXTURE				m_D3DTex[ TEXTURE_MAX ];							//!< eNX`\
	D3DFONT					m_D3DFont[ FONT_MAX ];								//!< tHg\
	D3DOBJECT				m_D3DObj[ OBJECT_MAX ];								//!< IuWFNg\

protected:
public:

};

// OO[oϐ-----------------------------------------------------------

// O֐vg^Cv錾-----------------------------------------------------

}	// namespace	DL

#ifdef __cplusplus
}
#endif

#endif	// __DLGRAPH_INCLUDE__
